/**
 * TestIt.java
 *
 * This program creates the threads that are used to demonstrate
 * the difference between notify() and notifyAll().
 *
 * @author Gagne, Galvin, Silberschatz
 * Operating System Concepts with Java - Sixth Edition
 * Copyright John Wiley & Sons - 2003.
 */

import java.util.concurrent.locks.*;

public class TestIt
{
    public static void main(String args[]) {
        Lock lock = new ReentrantLock();
        Condition [] c = new Condition[5];
        DoWork pile = new DoWork();

        Thread[] bees = new Thread[5];
        
        for (int i=0; i < 5; i++)
           c[i] = lock.newCondition();

        for (int i = 1; i <= 5; i++)
        {  
            bees[i-1] = new Thread(new Worker(pile, "Worker " + (new Integer(i)).toString(), i, lock, c) );
        }

        for (int i = 1; i <= 5; i++)
            bees[i-1].start();
    }
}

