/**
 * Worker.java
 * 
 * This thread is used to demonstrate the difference between notify() and
 * notifyAll().
 */

import java.util.concurrent.locks.*;

public class Worker implements Runnable {
	private DoWork pile;

	private String name;

	private int num;
	
	private Lock lock;
	
	private Condition [] c;

	public Worker(DoWork p, String n, int i, Lock lock, Condition [] c) {
		pile = p;
		name = n;
		num = i;
		this.lock = lock;
		this.c = c;
	}

	public void run() {
		while (true) {
			SleepUtilities.nap();
			pile.doWork(num, lock, c);
		}
	}

}
